/*
 * com2hex.c - convert core-image file to intellec HEX format
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>



void	usage()
{
	fprintf(stderr, "Usage: com2hex [-b bias] [file1] [>file2]\n");
}



FILE	*efopen(char *file, char *mode)
{
	FILE	*fp;

	if ((fp = fopen(file, mode)) == NULL) {
		perror(file);
		exit(1);
	}
	return (fp);
}



void	puthexb(int c)
{
	int	b;

	b = (c >> 4) & 0x0f;
	putchar(b < 10 ? b + '0' : b - 10 + 'A');
	b = c & 0x0f;
	putchar(b < 10 ? b + '0' : b - 10 + 'A');
}



main(int argc, char *argv[])
{
	static	char	buff[16];
	char	*e;
	unsigned loc = 0;
	int	i, n, sum;
	FILE	*ifp;

	while (++argv, --argc > 0 && argv[0][0] == '-') {
		switch (argv[0][1]) {
		case 'b':
			errno = 0;
			if (argv[0][2]) {
				loc = strtol(argv[0] + 2, &e, 16);
			} else {
				if (argc < 0) {
					usage();
					exit(2);
				}
				argc--;
				loc = strtol(*++argv, &e, 16);
			}
			if (errno || *e != '\0') {
				fprintf(stderr, "com2hex: bad bias\n");
				exit(2);
			}
			break;
		default:
			usage();
			exit(2);
		}
	}
	if (argc > 1) {
		usage();
		exit(2);
	}
	if (argc == 1) {
		ifp = efopen(argv[0], "rb");
	} else {
		fsetbin(stdin);
		ifp = stdin;
	}
	while ((n = fread(buff, 1, 16, ifp)) > 0) {
		putchar(':');
		puthexb(n);
		puthexb(loc >> 8);
		puthexb(loc);
		puthexb(0);
		sum = n;
		sum += loc & 0xff;
		sum += loc >> 8;
		for (i = 0; i < n; i++) {
			puthexb(buff[i]);
			sum += buff[i];
		}
		puthexb(-sum);
		putchar('\n');
		loc += n;
	}
	printf(":00000001FF\n");
	fclose(ifp);
	exit(0);
}
